<template>
    <v-container fluid>
        <v-col lg="4" class="mx-auto" md="12" sm="12">
            <v-card outlined class="pa-3 mx-auto" :elevation="4">
                <v-alert v-if="err != ''" dense text type="error">
                    {{err}}
                </v-alert>
                <v-alert v-if="ok != ''" dense text type="success">
                    {{success}}
                </v-alert>
                <v-card-title>Create Rule</v-card-title>
                <v-card-text>

                    <v-form ref='form' v-model="valid">
                        <v-row>
                            <v-text-field label="Rule Name"
                                          name="Rule Name"
                                          :counter="64"
                                          v-model="name"
                                          :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.rules' :''"
                                          :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.rules' : ''"
                                          required
                                          :rules="rules"
                                          type="text"/>
                        </v-row>
                        <v-row>
                            <v-text-field label="Rule Description"
                                          name="Rule Description"
                                          v-model="description"
                                          :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.desc' :''"
                                          :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.desc' : ''"
                                          required
                                          :rules="required"
                                          type="text"/>
                        </v-row>
                        <v-row>
                            <v-select
                                    label="Trigger Type"
                                    name="Trigger Type"
                                    :items="TriggerType"
                                    v-model="type"
                                    item-value="value"
                                    item-text="name"
                                    :hint="Hint"
                                    persistent-hint
                                    required
                                    :rules="required"
                                    single-line
                                    :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.triggerType' :''"
                                    :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.triggerType' : ''"

                                    @input="Update"
                            />
                        </v-row>
                        <v-row>
                            <v-combobox v-model="labels"
                                        :items="existingLabels"
                                        label="Labels"
                                        name="Labels"
                                        :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.label' :''"
                                        :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.label' : ''"
                                        hint="Add existing or create new labels"
                                        persistent-hint
                                        multiple>
                                <template v-slot:selection="data">
                                    <v-chip
                                            :key="JSON.stringify(data.item)"
                                            v-bind="data.attrs"
                                            :input-value="data.selected"
                                            :disabled="data.disabled"
                                            @click:close="data.parent.selectItem(data.item)"
                                    >
                                        <v-avatar
                                                class="accent white--text"
                                                left
                                                v-text="data.item.slice(0, 1).toUpperCase()"
                                        ></v-avatar>
                                        {{ data.item }}
                                    </v-chip>
                                </template>

                            </v-combobox>
                        </v-row>
                        <v-row v-show="triggers.length > 0">
                            <v-select label="Trigger"
                                      name="Trigger"
                                      :items="triggers"
                                      v-model="selectedTrigger"
                                      item-text="name"
                                      :hint="TriggerHint"
                                      persistent-hint
                                      return-object
                                      required
                                      :rules="required"
                                      single-line
                                      :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.trigger' :''"
                                      :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.trigger' : ''"/>
                        </v-row>
                        <v-row v-show="actions.length > 0">
                            <v-select label="Action"
                                      name="Action"
                                      :items="actions"
                                      v-model="selectedAction"
                                      item-text="name"
                                      :hint="ActionHint"
                                      persistent-hint
                                      return-object
                                      required
                                      :rules="required"
                                      single-line
                                      :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.action' :''"
                                      :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.action' : ''"/>
                        </v-row>

                    </v-form>
                </v-card-text>
                <v-card-actions>
                    <v-btn color="primary" to="/rule">
                        Back
                    </v-btn>
                    <v-spacer/>
                    <v-btn color="primary" :disabled="!valid" @click="Create">
                        Create
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-col>


    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component} from 'vue-property-decorator';
    import {Validable} from "../../mixins/Validable";
    import {Initializable} from "../../mixins/Initializable";
    import {Mixins} from "vue-mixin-decorator";
    import {coreApi, triggerType} from "../../init";
    import {TriggerResponse} from "../../../../classLibrary/core/triggerResponse";
    import {RuleActionResponse} from "../../../../classLibrary/core/ruleActionResponse";


    interface AnalyticsMixin extends Validable, Initializable {
    }

    @Component
    export default class CreateRule extends Mixins<AnalyticsMixin>(Validable, Initializable) {
        valid: boolean = false;

        rules = [
            (v: any) => !!v || 'Rule Name is required',
            (v: any) => (v && v.length >= 4) || 'Rule Name must be at least 4 characters long',
            (v: any) => (v && v.length <= 64) || 'Rule Name cannot exceed 64 characters long',
        ]
        required = [
            (v: any) => !!v || 'Required',
        ]

        name: string = '';
        code: string = '';
        description: string = '';
        type: string = '';
        labels: string[] = [];

        existingLabels: string[] = [];

        triggers: TriggerResponse[] = [];
        actions: RuleActionResponse[] = [];

        selectedTrigger?: TriggerResponse | null = new TriggerResponse('', '', [], '', '', '');
        selectedAction?: RuleActionResponse | null = new RuleActionResponse('', '', [], '', '', '', '', '')

        get TriggerHint(): string {
            return this.selectedTrigger?.description ?? "";
        }

        get ActionHint(): string {
            return this.selectedAction?.description ?? "";
        }

        async init() {
            const e = await coreApi.Get<string[]>('Rule/labels');
            if (e.success) {
                this.existingLabels = e.Ok!;
            }
        }
        async Update() {
            if (this.type != '') {
                this.err = "";
                this.selectedTrigger = null;
                this.selectedAction = null;
                const triggerResult = await coreApi.Get<TriggerResponse[]>(`Trigger?triggerType=${this.type}`);
                if (triggerResult.success) {
                    this.triggers = triggerResult.Ok!;
                } else {
                    this.err = triggerResult.error!;
                    this.triggers = [];
                }
                const actionResult = await coreApi.Get<RuleActionResponse[]>(`Action?triggerType=${this.type}`);
                if (actionResult.success) {
                    this.actions = actionResult.Ok!;
                } else {
                    this.err = actionResult.error!;
                    this.actions = [];
                }
            }
        }

        get Hint(): string {
            return this.TriggerType
                .Find(x => x.value === this.type)?.desc ?? ""
        }

        get TriggerType(): { name: string, value: string, desc: string }[] {
            return triggerType;
        }

        async Create() {
            if (this.valid) {

                const r = await coreApi.Post<RuleActionResponse>("Rule", {
                    name: this.name,
                    actionId: this.selectedAction?.id,
                    triggerId: this.selectedTrigger?.id,
                    description: this.description,
                    labels: this.labels,
                    triggerType: this.type,
                    meta: JSON.stringify({}),
                });
                if (r.success) {
                    this.ok = "Successfully created Rule!";
                    // await this.$router.push(`/trigger/${r.Ok!.id}`);
                } else {
                    this.err = r.error!;
                }

            }
        }
    }
</script>
